<?php
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
#        Copyright  Jrme LEIGNADIER-PARADON 2008 - ged.charrette@free.fr         #
#                          http://www.ged-charrette.net                             #
#                                                                                   #
# Ce fichier est une partie du logiciel libre "Charette", licenci cumulativement   #
# sous "GNU Affero GPL version 3" et "CeCILL-C version 2".                          #
# La double licence est dcrite plus prcisment dans les fichiers :                #
#    /public/charrette/langues/fr/licences_fr.txt                                   #
#    /public/charrette/langues/en/licences_en.txt                                   #
#                                                                                   #
#         ATTENTION, CE LOGICIEL EST DISTRIBU SANS GARANTIE D'AUCUNE SORTE         #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


//$nav=$_get['nav'] ne fonctione pas toujour car les "+" sont remplac par des espace !
if (isset($_GET['nav'])){
	preg_match('#(?<=nav=)[^&]+#', $_SERVER['QUERY_STRING'], $f);
	$nav=$f[0];
	$nav = eregi_replace("[^a-z0-9._#/\+-]", '', $nav);
	$nav=trim($nav,"/");
	$nav = str_replace("..", "", $nav);
	//$nav = str_replace("/.", "/", $nav);
}




function netoyage_nom($name_file){// netoyage nom pour la cration de document ou de repertoire
	$name_file = trim($name_file, ' .');//supression de tout les point et espace au debut et  la fin
	$name_file = strtr($name_file,
	' ',
	'_AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');//supresion des accents
	$name_file = str_replace('', 'ae', $name_file);
	$name_file = str_replace('', 'AE', $name_file);
	$name_file = str_replace('', 'oe', $name_file);
	$name_file = str_replace('', 'OE', $name_file);
	$name_file = preg_replace('/([^a-z0-9\+\-_])/i', '_', $name_file); //remplace tout ce qui n'est pas "a-z 0-9 +-_" par un "_"
	$name_file = strtoupper($name_file);/*** rendre optionel*/ //passage en majuscule
return $name_file;}





/***
include("res/generateur_de_mot_de_passe.php"):*/
function nouveau_mot_de_pass_base(){
	$pw='';$p1='';$p2='';$p3='';
	$c = 'abcdefghijkmnopqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ1234567890+-*_&$?';

	for($i=0;$i < 2; $i++){
		$p1 .= $c[rand(1, strlen($c))-1];
		if (rand(0,2)==1){$p1 .= $l[rand(1, strlen($l))-1];}
	    $p1 .= $v[rand(1, strlen($v))-1];
	}
	$p2 = rand(10,999);
	$p3=$s[rand(1, strlen($s))-1];

	switch (rand(1,8)) {
		case 1: $pw = rtrim($p1.$p2.$p3);break;
		case 2: $pw = rtrim($p1.$p3.$p2);break;
		case 3: $pw = rtrim($p2.$p1.$p3);break;
		case 4: $pw = rtrim($p2.$p3.$p1);break;
		case 5: $pw = rtrim($p3.$p1.$p2);break;
		case 6: $pw = rtrim($p3.$p2.$p1);break;
		case 7: $pw = rtrim($p1.$p3.$p2);break;
		case 8: $pw = rtrim($p2.$p3.$p1);break;
	}
return $pw;}








function log2courriel($log){//requette d'adresse courielle a partire de l'identifiant
	$ret="";
	$csv = fopen('base/utilisateurs.csv', 'rb');
	while (($i = fgetcsv($csv, 1000, ",")) !== FALSE){
		if ($log == $i[1]){
			$ret=$i[3];
		}
	}
	fclose($csv);
	return $ret;

}





function def_niv($loca){/*** rendre "$loca" optionel*/  //definition du niveau d'autorisation dans la navigation
	global $fonds,$nav,$destinataire;
	if ($nav!="")$loca=$nav;
	$ret=$_SESSION['niv'];
	if ($_SESSION['niv'] > 1){// acces administrateu{
		$expl=explode('/', $loca);
		$reco="";
		foreach($expl as $i){
			$reco.="/".$i;
			if(file_exists($fonds.$reco."/.~groupe.csv")){
				$csv = fopen($fonds.$reco."/.~groupe.csv", 'rb');
				while (($j = fgetcsv($csv, 1000, ",")) !== FALSE) {
					if ($_SESSION['log'] == $j[0]){
						$ret=min($j[1],$ret);
					}
				}
				fclose($csv);
			}
		}
	}
	return $ret;
}



function user_aff(){//remplissage de la liste des adresse couriel des destinataires par affaire
	global $fonds,$aff,$destinataire,$courriel;
	if(file_exists($fonds."/".$aff."/.~groupe.csv")){
		$csv = fopen($fonds."/".$aff."/.~groupe.csv", 'rb');
		while (($j = fgetcsv($csv, 1000, ",")) !== FALSE) {
			if ($_SESSION['log'] != $j[0]){
				$destinataire.=log2courriel($j[0]).","; 
			}
		}
		$destinataire=trim($destinataire.$courriel,",");
		fclose($csv);
	}
}




$csv = fopen('public/charrette/langues/'.$langue."/dialogues.csv", 'rb');
while (($i = fgetcsv($csv, 1000, ";")) !== FALSE) {
		$messages[$i[0]]=$i[1];
}
fclose($csv);
function message($num,$fic= NULL,$nom= NULL){
	global $messages;
	$ret=$messages[$num];
	$ret= str_replace('\n',"\r\n",$ret);
	$ret= ereg_replace("\[#fic#\]",$fic,$ret);
	$ret= ereg_replace("\[#nom#\]",$nom,$ret);
	return $ret;
}





function courriel($corp,$titre= NULL){//generation d'un courriel
	global $aff,$destinataire,$courriel;
	$entete="From:".$courriel."\n";
	mail($destinataire, "[charrette][".$aff."]".$titre, $corp, $entete);
}

?>